// SviUsbControl.cpp: CSviUsbControl NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SviUsbControl.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CSviUsbControl::CSviUsbControl()
{
	// oϐ
	RC=0;
	// SVICu[
	SVIUSB20_Init();
	// ڑSVI-03{[h擾
	ScanBoard();
}

CSviUsbControl::~CSviUsbControl()
{
	//SVIhCoEN[Y
	SVIUSB20_Close(SVIUSB20_APP_WHO_CTL);
	//SVI{[hI
	SVIUSB20_DeviceRelease();
	//SVICu[I
	SVIUSB20_End();
}
//G[R[h擾܂BiG[R[h͏܂B)
DWORD CSviUsbControl::getLastError(void)
{
	DWORD outputRC = RC;
	RC = 0;
	return outputRC;
}

//G[R[h𕶎ɕϊ܂B
CString CSviUsbControl::getLastErrorString(DWORD errorcode)
{
	CString outputString;
	switch(errorcode)
	{
	case SVIUSB20_RET_NORMAL:
		outputString = "I";
		break;
	case SVIUSB20_RET_ERROR_DEVOPEN:
		outputString = "SVIpUSB2.0hCoI[vł܂";
		break;
	case SVIUSB20_RET_ERROR_MULTIOPEN:
		outputString = "AvP[V͓dɃI[vł܂";
		break;
	case SVIUSB20_RET_ERROR_PARAMETER:
		outputString = "ɊԈႢ܂";
		break;
	case SVIUSB20_RET_ERROR_NOOPEN:
		outputString = "hCoI[vĂ܂B";
		break;

	case SVIUSB20_RET_ERROR_COM:
		outputString = "SVIUSB20_RET_ERROR_COM";
		break;
	case SVIUSB20_RET_ERROR_NOIDLE:
		outputString = "SVIUSB20_RET_ERROR_NOIDLE";
		break;
	case SVIUSB20_RET_ERROR_FMUPDATE_T:
		outputString = "SVIUSB20_RET_ERROR_FMUPDATE_T";
		break;
	case SVIUSB20_RET_ERROR_FPUPDATE_T:
		outputString = "SVIUSB20_RET_ERROR_FPUPDATE_T";
		break;
	case SVIUSB20_RET_ERROR_GSTS2_T:
		outputString = "SVIUSB20_RET_ERROR_GSTS2_T";
		break;
	case SVIUSB20_RET_ERROR_MDATA_T:
		outputString = "SVIUSB20_RET_ERROR_MDATA_T";
		break;
	case SVIUSB20_RET_ERROR_SVI:
		outputString = "SVIUSB20_RET_ERROR_SVI";
		break;

	default:
		outputString.Format("Win32APIG[F%x",errorcode);
		break;
	}

	return outputString;
}

//G[`FbNPiprivate)
bool CSviUsbControl::checkLastError(void)
{
	if(RC != SVIUSB20_RET_NORMAL)
	{
		TRACE(getLastErrorString(RC));
		return false;
	}
	return true;
}

//SVIhCoI[v܂
bool CSviUsbControl::open()
{
	//Rg[[hŃI[v
	RC = SVIUSB20_Open(SVIUSB20_APP_WHO_CTL);
	return checkLastError();
}

//SVIn[hEFA܂
bool CSviUsbControl::DeviceReset()
{
	//SVIZbg
	RC = SVIUSB20_DeviceReset();
	return checkLastError();
}

//SVIXe[^XXV܂(onlyBaseStatus : {Xe[^X̂ݍXVj
bool CSviUsbControl::refreshStatus(bool onlyBaseStatus)
{
	if(onlyBaseStatus == true)
	{
		//ڍ׃Xe[^X擾
		ULONG workStatus;
		RC = SVIUSB20_GetStatus2(&workStatus);
		if(checkLastError() == false)
		{
			return false;
		}
		//Xe[^XXV
		SviStatus.setBaseStatus(workStatus);
	}
	else
	{
		GET_STATUS workStatus;
		//ڍ׃Xe[^X擾
		RC = SVIUSB20_GetStatus(&workStatus);
		if(checkLastError() == false)
		{
			return false;
		}
		//Xe[^XXV
		SviStatus.setStatus(workStatus);
	}

	return true;
}


// PoCgM
//DEL bool CSviUsbControl::I2COneByteWrite(ULONG ulSendData)
//DEL {
//DEL 	RC = SVIUSB20_I2COneByteWrite(ulSendData);
//DEL 	return checkLastError();
//DEL }

// PoCgM
//DEL bool CSviUsbControl::I2COneByteRead(ULONG ulAckFlag, PULONG pulRcvData)
//DEL {
//DEL 	RC = SVIUSB20_I2COneByteRead(ulAckFlag,pulRcvData);
//DEL 	return checkLastError();
//DEL }

// X^[gRfBV
//DEL bool CSviUsbControl::I2CStart(ULONG ulReadFlag)
//DEL {
//DEL 	RC = SVIUSB20_I2CStart(ulReadFlag);
//DEL 	return checkLastError();
//DEL }
// XgbvRfBV
bool CSviUsbControl::I2CStop()
{
	RC = SVIUSB20_I2CStop();
	return checkLastError();
}


// J̃WX^֐ݒ
bool CSviUsbControl::SetValue(ULONG ulSlaveAdr,PUSHORT pRcvBuff,ULONG ulLen)
{
	vector<UCHAR> ucData;
	ULONG i, j;
	ULONG ulBlkLen;
	bool rf = false;

	// foCXhCoI[v
	if(!open())
		goto svi_close;

#if 1 // EFCgA[hTuAhXɑΉ 2006.1.13 update >>>>>>>>>>>>>>>>
	for(i = 0; i < ulLen; )
	{
		if(pRcvBuff[i] & 0x8000)
		{
			// wb_
			if( (pRcvBuff[i] & 0xFF00) == 0x8100)
			{
				// EFCg
				Sleep(pRcvBuff[i+1]);
				i += pRcvBuff[i] & 0xFF;
				continue;
			}
			ulBlkLen = pRcvBuff[i] & 0xFF;
			if(ucData.size() < ulBlkLen)
				ucData.resize(ulBlkLen - 1);
			for (j = 0; j < ulBlkLen - 1; j++)
				ucData[j] = (UCHAR) pRcvBuff[i+1+j] & 0xFF;
			if(!I2CBlockWrite(ulSlaveAdr, ulBlkLen - 1, 0, &(ucData[0])))
				goto svi_close;
			i += ulBlkLen;
		}
		else
			i++;		// wb_T[`
	}
#else // 2006.1.13 update <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#if 1 // ubNMɕύX - 2005.03.29 SKY Kashiwagi
	if(!I2CBlockWrite(ulSlaveAdr, ulLen, 0, pRcvBuff))
		goto svi_close;
#else // ubNMɕύX - 2005.03.29 SKY Kashiwagi
	ULONG ulwork,i,ulReadFlag;
	ulReadFlag = FALSE;
	for(i=0;i<ulLen;i++){

		// I2CX^[gRfBVʒm
		if(!I2CStart(ulReadFlag))
			goto svi_close;

		// I2C1oCgM
		// X[uAhX̏
		if(!I2COneByteWrite((ulSlaveAdr<<1)))
			goto svi_close;

		ulwork = 0;
		// I2C1oCgM
		// TuAhX̏
		memcpy(&ulwork,&pRcvBuff[i],1);
		if(!I2COneByteWrite(ulwork))
			goto svi_close;

		ulwork = 0;
		// I2C1oCgM
		// f[^̏
		i++;
		memcpy(&ulwork,&pRcvBuff[i],1);
		if(!I2COneByteWrite(ulwork))
			goto svi_close;

		// I2CXgbvRfBVʒm
		if(!I2CStop())
			goto svi_close;
	}
#endif // ubNMɕύX - 2005.03.29 SKY Kashiwagi
#endif // ubNMsC - 2005.10.19 V3.10
	rf = true;
svi_close:
	// foCXhCoN[Y
	RC = SVIUSB20_Close(SVIUSB20_APP_WHO_CTL);
	checkLastError();
	return rf;
}

// J̃WX^֐ݒ
bool CSviUsbControl::SetValue(ULONG ulSlaveAdr,ULONG ulSubAdr,PUCHAR pRcvBuff,ULONG ulLen, BOOL bWord)
{
	bool rf = false;
	// foCXhCoI[v
	if(!open())
		goto svi_close;

	UCHAR ucBuf[80];
	ULONG i, j;
	if(!bWord)
	{
		ucBuf[0] = (UCHAR)ulSubAdr & 0xFF;
		j = 1;
	}
	else
	{
		ucBuf[0] = (UCHAR)(ulSubAdr >> 8) & 0xFF;
		ucBuf[1] = (UCHAR)ulSubAdr & 0xFF;
		j = 2;
	}
	for(i=j;i<ulLen+j;i++) ucBuf[i] = *(pRcvBuff+(i-j));
	if(!I2CBlockWrite(ulSlaveAdr, ulLen+j, 0, &ucBuf[0]))
		goto svi_close;

	// I2CXgbvRfBVʒm
	//if(!I2CStop())
	//	goto svi_close;

	rf = true;

svi_close:
	// foCXhCoN[Y
	RC = SVIUSB20_Close(SVIUSB20_APP_WHO_CTL);
	checkLastError();
	return rf;
}

// J̃WX^֐ݒ
bool CSviUsbControl::SetValue2(ULONG ulSlaveAdr,ULONG ulSubAdr,PUCHAR pRcvBuff,ULONG ulLen, BOOL bWord)
{
	UCHAR ucBuf[80];
	ULONG i, j;
	if(!bWord)
	{
		ucBuf[0] = (UCHAR)ulSubAdr & 0xFF;
		j = 1;
	}
	else
	{
		ucBuf[0] = (UCHAR)(ulSubAdr >> 8) & 0xFF;
		ucBuf[1] = (UCHAR)ulSubAdr & 0xFF;
		j = 2;
	}
	for(i=j;i<ulLen+j;i++) ucBuf[i] = *(pRcvBuff+(i-j));
	if(!I2CBlockWrite(ulSlaveAdr, ulLen+j, 0, &ucBuf[0])) return false;

	return true;
}

#if 1 // 2012.07.24 V3.2.2.0
bool CSviUsbControl::GetValue(ULONG ulSlaveAdr,ULONG ulSubAdr,PUCHAR pRcvBuff,ULONG ulLen, BOOL bWord, BOOL bRestart)
#else
bool CSviUsbControl::GetValue(ULONG ulSlaveAdr,ULONG ulSubAdr,PUCHAR pRcvBuff,ULONG ulLen, BOOL bWord)
#endif // 2012.07.24 V3.2.2.0
{
	bool rf = false;
	// foCXhCoI[v
	if(!open())
		goto svi_close;

#if 1 // ubNMɕύX - 2005.03.29 SKY Kashiwagi
	// Sub address word  Ή 2006.1.13 update >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	UCHAR ucBuf[80];
	ULONG i;
	if(!bWord)
	{
		ucBuf[0] = (UCHAR)ulSubAdr & 0xFF;
		i = 1;
	}
	else
	{
		ucBuf[0] = (UCHAR)(ulSubAdr >> 8) & 0xFF;
		ucBuf[1] = (UCHAR)ulSubAdr & 0xFF;
		i = 2;
	}
	//for(i=1;i<=ulLen;i++) ucBuf[i] = *(pRcvBuff+i);
#if 0 // 2006.11.07 V3.1.6.0 [h̏ꍇXgbvRfBV𔭍sAX^[gRfBVƂ
	if(!I2CBlockWrite(ulSlaveAdr, i, 0x80000000, &ucBuf[0]))
		goto svi_close;
	if(!I2CBlockRead(ulSlaveAdr, ulLen, 0x80000000, pRcvBuff))
		goto svi_close;
#else // 2007.04.24 V3.1.6.1 DPDW[̏ꍇ̓X^[gRfBVȂ
#if 1 // 2012.07.24 V3.2.2.0
	if(bRestart == true){
		if(!I2CBlockWrite(ulSlaveAdr, i, 0x80000000, &ucBuf[0]))
			goto svi_close;
		if(!I2CBlockRead(ulSlaveAdr, ulLen, 0x80000000, pRcvBuff))
			goto svi_close;
	}else{
		if(!I2CBlockWrite(ulSlaveAdr, i, 0, &ucBuf[0]))
			goto svi_close;
		if(!I2CBlockRead(ulSlaveAdr, ulLen, 0, pRcvBuff))
			goto svi_close;
	}
#else
	if(!I2CBlockWrite(ulSlaveAdr, i, 0, &ucBuf[0]))
		goto svi_close;
	if(!I2CBlockRead(ulSlaveAdr, ulLen, 0, pRcvBuff))
		goto svi_close;
#endif // 2012.07.24 V3.2.2.0
#endif // 2006.11.07 V3.1.6.0
	// Sub address word  Ή 2006.1.13 update <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#else // ubNMɕύX - 2005.03.29 SKY Kashiwagi
	// I2CX^[gRfBVʒm
	ULONG ulReadFlag;
	ulReadFlag = TRUE;
	if(!I2CStart(ulReadFlag))
		goto svi_close;

	// I2C1oCgM
	// X[uAhX̏
	if(!I2COneByteWrite((ulSlaveAdr<<1)))
		goto svi_close;

	// I2C1oCgM
	// TuAhX̏
	if(!I2COneByteWrite(ulSubAdr))
		goto svi_close;

	Sleep(10);

	// I2CXgbvRfBVʒm
	if(!I2CStop())
		goto svi_close;

// ubNM
/*
#if 0

	// I2CXgbvRfBVʒm
	if(!I2CStop())
		goto svi_close;

	ulReadFlag = 2;
	if(!I2CStart(ulReadFlag))
		goto svi_close;

	if(!I2COneBlockRead(ulSlaveAdr,ulLen,pRcvBuff))
		goto svi_close;
#endif
*/

	ulReadFlag = TRUE;
	if(!I2CStart(ulReadFlag))
		goto svi_close;

	// I2C1oCgM
	// X[uAhX̏
	if(!I2COneByteWrite((ulSlaveAdr<<1|1)))
		goto svi_close;

	ULONG ulAckFlag,i,ulData;
	for(i=0; i < ulLen;i++)
	{
		Sleep(1);
		// I2C1oCgM
		if((i+1) == ulLen) ulAckFlag = FALSE;
		else ulAckFlag = TRUE;
		if(!I2COneByteRead(ulAckFlag,&ulData))
			goto svi_close;
		memcpy(&pRcvBuff[i],&ulData,1);
	}

	// I2CXgbvRfBVʒm
	if(!I2CStop())
		goto svi_close;
#endif // ubNMɕύX - 2005.03.29 SKY Kashiwagi

	rf = true;
svi_close:
	// foCXhCoN[Y
	RC = SVIUSB20_Close(SVIUSB20_APP_WHO_CTL);
	checkLastError();
	return rf;
}

bool CSviUsbControl::I2CBlockWrite(ULONG ulSlaveAdr, ULONG ulLen, ULONG ulWriteMode, PUCHAR pucSendBuf)
{
	RC = SVIUSB20_I2COneBlockWrite( ulSlaveAdr, ulLen, ulWriteMode, pucSendBuf);
	return checkLastError();
}

bool CSviUsbControl::I2CBlockRead(ULONG ulSlaveAdr, ULONG ulLen, ULONG ulReadMode, PUCHAR pucRcvBuf)
{
	RC = SVIUSB20_I2COneBlockRead( ulSlaveAdr, ulLen, ulReadMode, pucRcvBuf);
	return checkLastError();
}

DWORD CSviUsbControl::ScanBoard()
{
	// ڑSVI-03{[h擾
	ulBoardNum = 0;
	memset(ulBoardInfo,0x0,sizeof(ULONG)*4);
	return SVIUSB20_EnumDevice(SVIUSB20_APP_WHO_CTL,&ulBoardNum,ulBoardInfo);
}

ULONG CSviUsbControl::GetBoardNum()
{
	return ulBoardNum;
}

ULONG CSviUsbControl::GetDeviceID(int no)
{
	return ulBoardInfo[no];
}

void CSviUsbControl::SetSelBoardNo(int no)
{
	ulSelBoardNo = ulBoardInfo[no];
	SVIUSB20_DeviceSelect(ulSelBoardNo);
}

bool CSviUsbControl::close()
{
	//Rg[[hŃN[Y
	RC = SVIUSB20_Close(SVIUSB20_APP_WHO_CTL);
	return checkLastError();
}
